<?php
/*
// The "Ultimate AJAX Newsflash" Module for Joomla 1.0.x - Version 2.0
// License: http://www.gnu.org/copyleft/gpl.html
// Authors: Fotis Evangelou - George Chouliaras
// Copyright (c) 2006 JoomlaWorks.gr - http://www.joomlaworks.gr
// Project page at http://www.joomlaworks.gr - Demos at http://demo.joomlaworks.gr
// Feel free to modify as you wish!
// ***Last update: September 25th, 2006***
*/

/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

global $mosConfig_locale;

// Module Parameters
$moduleclass_sfx		= $params->get( 'moduleclass_sfx', '' );
$where					= $params->get( 'where', 'category' );
$where_id				= trim( $params->get( 'where_id', '' ) );
$ordering				= $params->get( 'ordering', 'rdate' );
$count					= intval( $params->get( 'count', 5 ) );
$bots					= intval( $params->get( 'bots', 1 ) );
$display				= intval( $params->get( 'display', 2 ) );
$linked					= intval( $params->get( 'linked', 1 ) );
$intro					= intval( $params->get( 'intro', 1 ) );
$chars					= intval( $params->get( 'chars', '' ) );
$words					= intval( $params->get( 'words', '' ) );
$more					= intval( $params->get( 'more', 1 ) );
$uniqueid 				= trim( $params->get( 'uniqueid' ) );
$customcss				= intval( $params->get( 'customcss', 1 ) );
$datecreated			= intval( $params->get( 'datecreated', 1 ) );
$show_front 			= intval($params->get( 'show_front', 0 ) );
$show_section_title 	= intval($params->get( 'show_section_title', 1 ) );
$show_category_title 	= intval($params->get( 'show_category_title', 1 ) );
$seperator 				= trim( $params->get( 'seperator', '&gt;&gt;' ) );

$ajaxnfwidth = trim( $params->get( 'ajaxnfwidth' ) );
$ajaxnfheight = trim( $params->get( 'ajaxnfheight' ) );
$delay = trim( $params->get( 'delay' ) );
$show_bottomfade = intval($params->get( 'show_bottomfade', 1 ) );

echo "\n<!-- JW Ultimate AJAX Newsflash (v2.0) starts here -->\n";
echo '
<style type="text/css" media="all">
<!--
#'.$uniqueid.' {
	position:relative;
	width:'.$ajaxnfwidth.';
	height:'.$ajaxnfheight.';
	margin:0px;
	padding:0px 4px;
	border:none;
	background-color: #ffffff;
	overflow:hidden;
}
#'.$uniqueid.' div { 
	background-color: #ffffff;
	/*IE6 bug fix when text is bold and fade effect (alpha filter) is enabled.
	Style this inner div with the same background color as the previous (outer) div!!! */
}

.'.$uniqueid.'_bottomfade { /* the bottom fade setup */
background:url("modules/mod_jw_ajaxnf/bottomfade.png") repeat-x bottom;
position:relative;height:20px;width:100%;margin-top:-20px;}

* html .'.$uniqueid.'_bottomfade {background-image:none;
filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src="modules/mod_jw_ajaxnf/bottomfade.png", sizingMethod="scale");
} 
';
if ($customcss) {
echo '
#'.$uniqueid.' {} /* Outer container */
#'.$uniqueid.' h1 {font-size:10px;padding:0px;margin:0px;font-weight:normal;background:none;border-bottom:1px solid #ddd;} /* Section/Category */
#'.$uniqueid.' h2 {font-size:14px;padding:0px;margin:4px 0px 0px 0px;} /* Item title */
#'.$uniqueid.' h3 {font-size:9px;padding:0px;margin:0px 0px 4px 0px;font-weight:normal;background:none;border:none;} /* Date */
#'.$uniqueid.' .introtext {padding:0px;margin:0px;} /* Style the introtext here */
#'.$uniqueid.' .introtext p {padding:0px;margin:0px;} /* Remove paragraph spacing */
#'.$uniqueid.' .readon {display:block;font-size:10px;padding:0px;margin:4px 0px 8px 0px;text-align:right;} /* "Readmore" button */';
}
echo '
-->
</style>';

// Content Output
if ($where == 'section' OR $where == 'category' OR $where == 'content') { // source is content section/category/item
	global $mosConfig_offset, $mainframe, $my;

	$now		= date( 'Y-m-d H:i:s', time() + $mosConfig_offset * 60 * 60 );
	$access		= !$mainframe->getCfg( 'shownoauth' );

	switch ( $ordering ) {
		case 'date':
			$orderby = 'a.created';
			break;
		case 'rdate':
			$orderby = 'a.created DESC';
			break;
		case 'alpha':
			$orderby = 'a.title';
			break;
		case 'ralpha':
			$orderby = 'a.title DESC';
			break;
		case 'hits':
			$orderby = 'a.hits DESC';
			break;
		case 'rhits':
			$orderby = 'a.hits ASC';
			break;
		case 'order':
		default:
			$orderby = 'a.ordering';
			break;
	}

	// select intro only or full text
	if ($intro) {
		$select = "a.introtext AS `text`";
	} else {
		$select = "CONCAT(a.introtext, a.fulltext) AS `text`";
	}

	// select between section, category
	switch ( $where ) {
		case 'content':
			$where_clause = "\n AND ( a.id IN (". $where_id .") )";
			break;
		case 'section':  // retrieve content item from specified section
			$where_clause = "\n AND ( a.sectionid IN (". $where_id .") )";
			break;
		case 'category':  // retrieve content item from specified category
		default:
			$where_clause = "\n AND ( a.catid IN (". $where_id .") )";
			break;
	}

	$query = "SELECT a.id, a.title, a.created, a.introtext, a.fulltext, $select, a.images, a.attribs AS `params`"
	. ", b.title as category_title, c.title as section_title"
	. "\n FROM #__content AS a"
	. "\n LEFT JOIN `#__categories` b ON b.id = a.catid"
	. "\n LEFT JOIN `#__sections` c ON c.id = a.sectionid"
	. "\n LEFT JOIN #__content_frontpage AS f ON f.content_id = a.id"
	. "\n WHERE ( a.state = '1' AND a.checked_out = '0' AND a.sectionid > '0' )"
	. "\n AND ( a.publish_up = '0000-00-00 00:00:00' OR a.publish_up <= '". $now ."' )"
	. "\n AND ( a.publish_down = '0000-00-00 00:00:00' OR a.publish_down >= '". $now ."' )"
   	. ( $access ? "\n AND a.access <= '". $my->gid ."'" : '' )
   	. ( $show_front == "0" ? "\n AND f.content_id IS NULL" : '' )
	. $where_clause
	. "\n ORDER BY $orderby LIMIT 0,$count"
	;
	$database->setQuery( $query );
	$rows = $database->loadObjectList();
	
	// needed to reduce queries used by getItemid for Content Items
	$bs 	= $mainframe->getBlogSectionCount();
	$bc 	= $mainframe->getBlogCategoryCount();
	$gbs 	= $mainframe->getGlobalBlogSectionCount();
} else { // source is newsfeed category/item
	global $mosConfig_absolute_path;
	
	require_once( $mosConfig_absolute_path . "/includes/domit/xml_domit_rss_lite.php");
	
	if ($where == 'newsfeed_item') {
		$condition = "AND id IN ($where_id)";
	} else {
		$condition = "AND catid IN ($where_id)";
	}
	
	$database->setQuery( "SELECT name, link, numarticles, cache_time"
	. "\n FROM #__newsfeeds"
	. "\n WHERE published='1' AND checked_out='0' $condition"
	. "\n ORDER BY ordering"
	);
	$newsfeeds = $database->loadObjectList();
	
	$displayed = 0;
	
	$rows = array();
	foreach ($newsfeeds as $newsfeed) {
		if ($displayed >= $count) break; else {
			$cacheDir = $mosConfig_absolute_path . "/cache/";
			$LitePath = $mosConfig_absolute_path . "/includes/Cache/Lite.php";
			require_once( $mosConfig_absolute_path . "/includes/domit/xml_domit_rss_lite.php");
			$rssDoc =& new xml_domit_rss_document_lite();
			$rssDoc->useCacheLite(true, $LitePath, $cacheDir, $newsfeed->cache_time);
			$rssDoc->loadRSS($newsfeed->link);
			$totalChannels = $rssDoc->getChannelCount();
			for ($i = 0; $i < $totalChannels; $i++) {
				$currChannel =& $rssDoc->getChannel($i);
				$actualItems = $currChannel->getItemCount();
				$setItems = $newsfeed->numarticles;
				if ($setItems > $actualItems) {
					$totalItems = $actualItems;
				} else {
					$totalItems = $setItems;
				}
				for ($j = 0; $j < $totalItems; $j++) {
					if ($displayed >= $count) break; else {
						$row = new stdClass();
						$currItem =& $currChannel->getItem($j);
						$row->title = $currItem->getTitle();
						$row->text = html_entity_decode($currItem->getDescription(), ENT_QUOTES);
						$row->link = $currItem->getLink();
						$displayed++;
						$rows[] = $row;
					}
				}
			}
		}
	}
}
// Output content items retrieved

$html2out = array();

foreach ( $rows as $row ) {
	if ($where == 'section' OR $where == 'category' OR $where == 'content') {
		$Itemid = $mainframe->getItemid( $row->id, 0, 0, $bs, $bc, $gbs );
	
		// Blank itemid check for SEF
		if ($Itemid == NULL) {
			$Itemid = '';
		} else {
			$Itemid = '&amp;Itemid='.$Itemid;
		}
	
		$link = sefRelToAbs( 'index.php?option=com_content&amp;task=view&amp;id='. $row->id . $Itemid );
	} else {
		$link = $row->link;
	}

	// if character limitation defined
	if ($chars) {
		$row->text = substr($row->text, 0, $chars).'...';
	}
	
	// if word limitation defined
	if ($words) {
		$word_arr = str_word_count($row->text, 2);
		$c = 0;
		foreach ($word_arr AS $k => $v) {
			if ($c == $words) {
				$row->text = substr($row->text, 0, $k).'...';
				break;
			}
			$c++;
		}
	}
	
	if ($bots AND ($where == 'section' OR $where == 'category' OR $where == 'content')) {
		$content_params =& new mosParameters( $row->params );

		// GC Parameters
		$content_params->def( 'link_titles', 	$mainframe->getCfg( 'link_titles' ) );
		$content_params->def( 'author', 		!$mainframe->getCfg( 'hideAuthor' ) );
		$content_params->def( 'createdate', 	!$mainframe->getCfg( 'hideCreateDate' ) );
		$content_params->def( 'modifydate', 	!$mainframe->getCfg( 'hideModifyDate' ) );
		$content_params->def( 'print', 			!$mainframe->getCfg( 'hidePrint' ) );
		$content_params->def( 'pdf', 			!$mainframe->getCfg( 'hidePdf' ) );
		$content_params->def( 'email', 			!$mainframe->getCfg( 'hideEmail' ) );
		$content_params->def( 'rating', 		$mainframe->getCfg( 'vote' ) );
		$content_params->def( 'icons', 			$mainframe->getCfg( 'icons' ) );
		$content_params->def( 'readmore', 		$mainframe->getCfg( 'readmore' ) );
		// Other Params
		$content_params->def( 'image', 			1 );
		$content_params->def( 'section', 		0 );
		$content_params->def( 'section_link', 	0 );
		$content_params->def( 'category', 		0 );
		$content_params->def( 'category_link', 	0 );
		$content_params->def( 'introtext', 		1 );
		$content_params->def( 'pageclass_sfx', 	'' );
		$content_params->def( 'item_title', 	1 );
		$content_params->def( 'url', 			1 );
	
		// process bots
		global $_MAMBOTS;
		$_MAMBOTS->loadBotGroup( 'content' );
		$_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$content_params, 0 ), true );
	} else {
		$row->text = preg_replace('/{([a-zA-Z0-9\-_]*)\s*(.*?)}/i', '', $row->text);
	}
	
// loop starts here

$html = "<div class=\"ajaxnf\">\n";
	// Section - Category display
	if ($show_section_title || $show_category_title) {
		$html .= '<h1>';
		if ($show_section_title) {
			 $html .= $row->section_title;
			 if ($show_category_title) { $html .= ' '.$seperator.' '.$row->category_title; }
		} else {
			 if ($show_category_title) { $html .= $row->category_title;}
		}
		$html .= '</h1>';
	}

	// Item title
	if ($display != 1) { // not set to show text only => show title
		$html .= '<h2>';
		if ($linked) { $html .= '<a href="'.$link.'">'; } // removed from link: class="readon'.$moduleclass_sfx.'"
		$html .= $row->title;
		if ($linked) { $html .= '</a>'; }
		$html .= '</h2>';
		$html .= "\n"; //line break
	}
	
	// Item creation date
	if ($datecreated) {
		setlocale (LC_TIME, $mosConfig_locale);
		$html .= '<h3>'.strftime("%d.%m.%y", strtotime($row->created)).'</h3>';
		$html .= "\n"; //line break
	}
	
	// Item introtext/fulltext
	if ($display != 0 OR $more) {
		$html .= '';
		if ($display != 0) {
		$html .= "<div class=\"introtext\">\n".$row->text."\n</div>";
		$html .= "\n"; //line break
		}
		if ($more) { $html .= '<a class="readon'.$moduleclass_sfx.'" href="'.$link.'">'._READ_MORE.'</a>'; }
		$html .= "</div>\n\n"; //line break
	}

$html2out[] = $html;
//loops ends here

}

// here we write the output to the bridge file, then the script reads the bridge file and outputs content...
$xmlout = "";
foreach ($html2out as $key => $value) { $xmlout.= "$value";}
$xml = fopen("modules/mod_jw_ajaxnf/content_$uniqueid.txt",'w');
fwrite($xml,$xmlout);
fclose($xml);

// end here
?>
<script type="text/javascript" src="modules/mod_jw_ajaxnf/mod_jw_ajaxnf.js" charset="utf-8"></script>
<script type="text/javascript">
/***********************************************
* Ajax Ticker script (txt file source) (c) Dynamic Drive (www.dynamicdrive.com)
* This notice MUST stay intact for legal use
* Visit http://www.dynamicdrive.com/ for this script and 100s more.
***********************************************/
var xmlfile="modules/mod_jw_ajaxnf/content_<?php echo $uniqueid; ?>.txt"
new ajax_ticker(xmlfile, "<?php echo $uniqueid; ?>", "optionalcssclasshere", <?php echo $delay; ?>, "fade")
</script>
<?php if ($show_bottomfade) { ?>
<div class="<?php echo $uniqueid; ?>_bottomfade"></div>
<?php } ?>
<!-- JW Ultimate AJAX Newsflash (v2.0) ends here -->
